"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("./multistatecheckbox.scss");
exports.default = function (p) {
    var onChange = p.onChange, children = p.children, className = p.className, disabled = p.disabled, value = p.value;
    var states = ['check_box_outline_blank', 'check_box', 'check_box', 'indeterminate_check_box'];
    return (React.createElement("div", { disabled: disabled, className: "field form-group multistate-checkbox" + " " + (className && className), onClick: function (e) {
            var val = (value || 0) + 1;
            ((val + 1) == (p.states || states).length) && (val = 0);
            return onChange(val);
        } },
        React.createElement("i", { className: "material-icons state-" + (value || 0) }, (p.states || states)[value || 0]),
        children && React.createElement("span", { className: "children" }, children)));
};
//# sourceMappingURL=multistatecheckbox.js.map