"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var bootstrap_1 = require("../commons/bootstrap");
require("./switch.scss");
exports.default = function (p) {
    var onChange = p.onChange, children = p.children, checked = p.checked, title = p.title, className = p.className;
    return (React.createElement("div", { className: "field form-group switch-wrapper " + (title && "with-title") + " " + (className && className) },
        title &&
            React.createElement("span", { className: "text" }, title),
        React.createElement(bootstrap_1.CheckBox, { className: "switch", onChange: onChange, checked: checked },
            React.createElement("div", { className: "slider round" }))));
};
//# sourceMappingURL=switch.js.map